<?php

/*******************************************************************************
 *                                                                             *
 *                         Плагин NeoMessenger ver:2.0.1                       *
 *                              Автор: NEOm@ster                               *
 *                         http://vk.com/filinov_victor                        *
 *                                                                             *
 *******************************************************************************/

    define('PATH', $_SERVER['DOCUMENT_ROOT']);
    include(PATH.'/core/ajax/ajax_core.php');

    // Обновляем онлайн статистику
    if (method_exists($inUser, 'onlineStats'))
    {
        $inUser->onlineStats();
    }
    else
    {
        $inCore->onlineStats();
    }

    $act = cmsCore::request('act', 'str', '');

    cmsCore::loadModel('users');
    $model_user = new cms_model_users;

    include 'nmcore.php';

/* -------------------------------------------------------------------------- */

    // Получаем количество новых сообщений
    if ($act == 'getNewMessagesCount')
    {
        cmsCore::jsonOutput(array(
            'count' => nmCore::getNewMessagesCount($inUser->id)
        ));
    }

/* -------------------------------------------------------------------------- */

    // Получаем список контактов
    if ($act == 'getСontacts')
    {
        $recipient_id = cmsCore::request('recipient_id', 'int', 0);

        if ($recipient_id)
        {
            // Если такого пользователя не существует выходим
            if (!nmCore::isUserExists($recipient_id)) cmsCore::halt();

            // Проверяем есть ли контакт в базе
            if (!nmCore::isContactExists($inUser->id, $recipient_id))
            {
                nmCore::addContact($inUser->id, $recipient_id);
            }
            else
            {
                nmCore::updateContactsDateLastMsg($inUser->id, $recipient_id);
            }
        }

        $contacts = nmCore::getContacts($inUser->id);

        cmsCore::jsonOutput($contacts);
    }

/* -------------------------------------------------------------------------- */

    // Получаем сообщения от контакта
    if ($act == 'getMessages')
    {
        $contact_id = cmsCore::request('contact_id', 'int', 0);

        // Если не указан ид выходим
        if (!$contact_id) cmsCore::halt();

        $messages = nmCore::getMessages($inUser->id, $contact_id);

        cmsCore::jsonOutput($messages);
    }

/* -------------------------------------------------------------------------- */

    // Обновление списка контактов и новых сообщений
    if ($act == 'getUpdate')
    {
        $contact_id  = cmsCore::request('contact_id', 'int', 0);
        $msg_last_id = cmsCore::request('message_last_id', 'int', 0);
        $cnt_last_id = cmsCore::request('contact_last_id', 'int', 0);

        $new_msgs_count = cmsUser::getNewMessages($inUser->id);

        $new_contacts = nmCore::getContacts($inUser->id, $cnt_last_id);
        $update = nmCore::getContactsUpdate($inUser->id);

        $contacts = array_replace_recursive($new_contacts['contacts'], $update);

        if ($new_msgs_count['notices'])
        {
            array_push($contacts, array(
                'id'           => '-1',
                'nickname'     => 'Уведомления',
                'avatar'       => '/plugins/p_neomessenger/img/information.png',
                'new_messages' => $new_msgs_count['notices']
            ));
        }
        
        $new_messages = array();

        foreach ($contacts as $contact)
        {
            if ($contact['id'] == $contact_id)
            {
                if ($contact['new_messages'] > 0)
                {
                    $new_messages = nmCore::getMessages($inUser->id, $contact_id, $msg_last_id);
                }
            }
        }

        cmsCore::jsonOutput(array(
            "contacts" => $contacts,
            'last_contact' => $new_contacts['last_contact'],
            'new_messages' => $new_messages,
            'count_messages' => $new_msgs_count['total']
        ));
    }

/* -------------------------------------------------------------------------- */

    // Удаляем сообщение
    if ($act == 'delMessage')
    {
        $message_id = cmsCore::request('message_id', 'int', 0);

        $message = $inDB->get_fields('cms_user_msg', "id='$message_id'", '*');

        if (!$message) cmsCore::halt();

        // Сообщение мне от пользователя
        if ($message['to_id'] == $inUser->id)
        {
            if ($message['from_id'] > 0)
            {
                $inDB->query("UPDATE cms_user_msg SET to_del=1 WHERE id='$message_id' LIMIT 1");
            }
            else
            {
                $inDB->query("DELETE FROM cms_user_msg WHERE id='$message_id' LIMIT 1");
            }
        }

        // Сообщение от меня пользователю
        if ($message['from_id'] == $inUser->id)
        {
            if ($message['is_new'])
            {
                $inDB->query("DELETE FROM cms_user_msg WHERE id='$message_id' LIMIT 1");
            }
            else
            {
                $inDB->query("UPDATE cms_user_msg SET from_del=1 WHERE id='$message_id' LIMIT 1");
            }
        }

        // Удаляем сообщения, которые удалены с двух сторон
        $inDB->query("DELETE FROM cms_user_msg WHERE to_del=1 AND from_del=1");

        cmsCore::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    // Удаляем сообщение
    if ($act == 'delContact')
    {
        $contact_id = cmsCore::request('contact_id', 'int', 0);

        if ($contact_id < 0)
        {
            // Удаляем уведомления
            $inDB->query("DELETE FROM cms_user_msg WHERE to_id='{$inUser->id}' AND from_id < 0");
        }
        else
        {
            // Проверяем есть ли контакт в базе
            if (nmCore::isContactExists($inUser->id, $contact_id))
            {
                $inDB->query("DELETE FROM cms_user_contacts WHERE user_id='{$inUser->id}' AND contact_id='$contact_id'");
            }
        }

        cmsCore::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    // Отправка сообщения
    if ($act == 'sendMessage')
    {
        $contact_id = cmsCore::request('contact_id', 'int', 0);
        $message    = cmsCore::request('message', 'html', '');
        $message    = cmsCore::parseSmiles($message, true);
        $last_id    = cmsCore::request('last_id', 'int', 0);

        // Отправка одному пользователю
        if (!cmsCore::inRequest('massmail')) {

            if (!nmCore::isContactExists($contact_id, $inUser->id))
            {
                nmCore::addContact($contact_id, $inUser->id);
            }

            nmCore::updateContactsDateLastMsg($inUser->id, $contact_id, true);

            // Отправляем сообщение
            $message_id = cmsUser::sendMessage($inUser->id, $contact_id, $message);

            // Отправляем уведомление на email если нужно
            $model_user->sendNotificationByEmail($contact_id, $inUser->id, $message_id);

            $messages = nmCore::getMessages($inUser->id, $contact_id, $last_id);

            cmsCore::jsonOutput($messages);

        }

        if (!$inUser->is_admin) cmsCore::halt();

        // отправить всем: получаем список всех пользователей
        $userlist = cmsUser::getAllUsers();

        if (!$userlist) {
            cmsCore::halt();
        }

        $count = array();

        // отправляем всем по списку
        foreach ($userlist as $user) {
            $count[] = cmsUser::sendMessage(USER_MASSMAIL, $user['id'], $message);
        }

        cmsCore::jsonOutput(array('alert' => sprintf($_LANG['SEND_MESS_ALL_OK'], sizeof($count))));
    }

/* -------------------------------------------------------------------------- */

    // Отмечает сообщение как прочитанное
    if ($act == 'setMsgReaded')
    {
        $message_id = cmsCore::request('message_id', 'int', 0);

        if ($message_id > 0) {
            $inDB->query("UPDATE cms_user_msg m SET is_new = 0 WHERE m.id = '$message_id' LIMIT 1");
        }

        cmsCore::jsonOutput(array('error' => false));
    }

/* -------------------------------------------------------------------------- */

    // Показывает старые сообщения
    if ($act == 'showOld')
    {
        $contact_id = cmsCore::request('contact_id', 'int', 0);
        $first_id = cmsCore::request('message_first_id', 'int', 0);

        $messages = nmCore::getMessages($inUser->id, $contact_id, 0, $first_id);

        cmsCore::jsonOutput($messages); 
    }

/* -------------------------------------------------------------------------- */

    cmsCore::halt();