<?php

class nmCore {

/* -------------------------------------------------------------------------- */

    // Получаем тулбар
    public static function getBBCodeToolbar()
    {
        $bbcodetoolbar = cmsPage::getBBCodeToolbar('nm-msg-field', true, 'users');
        $bbcodetoolbar = preg_replace('/onclick=".*?smilespanel.*?"/i', 'id="nm-smiles-btn"', $bbcodetoolbar);
        $bbcodetoolbar = preg_replace('/(\.ajax-loader)/i', '#nm-composer $1', $bbcodetoolbar);
        $bbcodetoolbar = preg_replace('/(panelfoto)/i', 'nm-$1', $bbcodetoolbar);
        return $bbcodetoolbar;
    }

/* -------------------------------------------------------------------------- */

    // Получаем список смайлов
    public static function getSmiles()
    {
        if ($handle = opendir(PATH . '/images/smilies'))
        {
            while (false !== ($file = readdir($handle)))
            {
                if ($file != '.' && $file != '..' && mb_strstr($file, '.gif'))
                {
                    $smiles[] = $file;
                }
            }

            closedir($handle);
        }

        return $smiles;
    }

/* -------------------------------------------------------------------------- */

    // Получаем количество новых сообщений
    public static function getNewMessagesCount($user_id)
    {
        return cmsDatabase::getInstance()->rows_count('cms_user_msg', "to_id = '$user_id' AND to_del = 0 AND is_new = 1");
    }

/* -------------------------------------------------------------------------- */

    // Получаем количество новых уведомлений
    public static function getNewNoticesCount($user_id)
    {
        return cmsDatabase::getInstance()->rows_count('cms_user_msg', "to_id = '$user_id' AND to_del = 0 AND is_new = 1 AND from_id < 0");
    }

/* -------------------------------------------------------------------------- */

    // Есть ли уведомления
    public static function isNoticesExists($user_id)
    {
        return (bool) cmsDatabase::getInstance()->rows_count('cms_user_msg', "to_id = '$user_id' AND to_del = 0 AND from_id < 0", 1);
    }

/* -------------------------------------------------------------------------- */

    // Есть ли такой пользователь
    public static function isUserExists($user_id)
    {
        return (bool) cmsDatabase::getInstance()->rows_count('cms_users', "id = '$user_id'", 1);
    }

/* -------------------------------------------------------------------------- */

    // Есть ли контакт в списке
    public static function isContactExists($user_id, $contact_id)
    {
        return (bool) cmsDatabase::getInstance()->rows_count('cms_user_contacts', "user_id = '$user_id' AND contact_id = '$contact_id'", 1);
    }

/* -------------------------------------------------------------------------- */

    // Добавляем юзера в список контактов
    public static function addContact($user_id, $contact_id)
    {
        return cmsDatabase::getInstance()->query("INSERT INTO cms_user_contacts (user_id, contact_id) VALUES ({$user_id}, {$contact_id})");
    }

/* -------------------------------------------------------------------------- */

    // Обновляет дату переписки с контактом
    public static function updateContactsDateLastMsg($user_id, $contact_id, $is_both = false)
    {
        $where = $is_both ? "user_id IN ($user_id, $contact_id) AND contact_id IN ($contact_id, $user_id)" : "user_id = $user_id AND contact_id = $contact_id";

        return cmsDatabase::getInstance()->query("UPDATE cms_user_contacts SET date_last_msg = CURRENT_TIMESTAMP WHERE $where");
    }

/* -------------------------------------------------------------------------- */

    // Получает список контактов
    public static function getContacts($user_id, $last_id = false)
    {
        $inDB = cmsDatabase::getInstance();

        $where = $last_id ? "AND c.id > $last_id" : '';

        $res = $inDB->query("
            SELECT u.id AS id, u.nickname AS nickname, u.login AS login, p.imageurl AS avatar, IFNULL(COUNT(m.id), 0) AS new_messages, IF(o.user_id, 1, 0) AS online, c.id AS last_contact
            FROM cms_user_contacts c
            LEFT JOIN cms_users AS u ON u.id = c.contact_id
            LEFT JOIN cms_user_profiles AS p ON p.user_id = u.id
            LEFT JOIN cms_user_msg AS m ON m.from_id = c.contact_id AND m.to_id = c.user_id AND m.is_new = 1 AND to_del = 0
            LEFT JOIN cms_online o ON o.user_id = u.id
            WHERE c.user_id = '$user_id'
            $where
            GROUP BY c.contact_id
            ORDER BY c.date_last_msg DESC
            LIMIT 1000
        ");

        $contacts = array();
        $last_contact = 0;

        if ($inDB->num_rows($res))
        {
            while ($contact = $inDB->fetch_assoc($res))
            {
                array_push($contacts, array(
                    'id'           => (int) $contact['id'],
                    'url'          => cmsUser::getProfileURL($contact['login']),
                    'avatar'       => cmsUser::getUserAvatarUrl($contact['id'], 'small', $contact['avatar']),
                    'online'       => $contact['online'],
                    'nickname'     => $contact['nickname'],
                    'new_messages' => $contact['new_messages']
                ));

                $last_contact = max($last_contact, $contact['last_contact']);
            }
        }

        if ($last_id) {
            return array(
                'contacts' => $contacts,
                'last_contact' => $last_contact
            );
        }

        if (self::isNoticesExists($user_id))
        {
            array_unshift($contacts, array(
                'id'           => '-1',
                'nickname'     => 'Уведомления',
                'avatar'       => '/plugins/p_neomessenger/img/information.png',
                'new_messages' => self::getNewNoticesCount($user_id)
            ));
        }

        return array(
            'contacts' => $contacts,
            'last_contact' => $last_contact
        );
    }

/* -------------------------------------------------------------------------- */

    public static function getMessages($user_id, $contact_id, $last_id = false, $first_id = false)
    {
        $inDB = cmsDatabase::getInstance();

        global $_LANG;

        $where = $last_id ? "AND m.id > '$last_id'" : ($first_id ? "AND m.id < '$first_id'" : "");

        if ($contact_id > 0)
        {
            $res = $inDB->query("
                SELECT m.id, m.from_id, m.is_new, m.senddate, m.message
                FROM cms_user_msg m
                WHERE
                    ((m.from_id = $user_id AND from_del = 0) OR (m.from_id = $contact_id AND to_del = 0)) AND
                    ((m.to_id = $user_id AND to_del = 0) OR (m.to_id = $contact_id AND from_del = 0)) $where
                ORDER BY m.id DESC
                LIMIT 21
            ");
        } else {
            $res = $inDB->query("
                SELECT m.id, m.from_id, m.is_new, m.senddate, m.message
                FROM cms_user_msg m
                WHERE m.from_id < 0 AND m.to_id = $user_id AND to_del = 0 $where
                ORDER BY m.id DESC
                LIMIT 21
            ");
        }
        
        if (!$inDB->num_rows($res))
        {
            return array(
                'messages'  => array(),
                'has_older' => false,
                'count'     => 0
            );
        }

        while ($msg = $inDB->fetch_assoc($res))
        {
            if ($msg['from_id'] < 0)
            {
                if ($msg['from_id'] == USER_UPDATER)
                {
                    $msg['service_name'] = $_LANG['SERVICE_UPDATE'];
                }

                if ($msg['from_id'] == USER_MASSMAIL)
                {
                    $msg['service_name'] = $_LANG['SERVICE_MAILING'];
                }

                $msg['from_id'] = '-1';
            }

            $msg['senddate'] = cmsCore::dateFormat($msg['senddate']);

            $msgs[] = $msg;
        }

        if (count($msgs) === 21 && ! $last_id)
        {
            $has_older = true;
            array_pop($msgs);
        }
        else
        {
            $has_older = false;
        }

        $msgs = is_array($msgs) && ! $first_id ? array_reverse($msgs) : $msgs;

        return array(
            'messages'  => $msgs,
            'has_older' => $has_older,
            'count'     => count($msgs)
        );
    }

/* -------------------------------------------------------------------------- */

    public static function onlineUpdate($ids, $user_id)
    {
        $inDB = cmsDatabase::getInstance();

        //собираем информацию о текущем пользователе
        $sess_id   = session_id();
        $ip        = cmsCore::strClear($_SERVER['REMOTE_ADDR']);
        $useragent = cmsCore::strClear((string) $_SERVER['HTTP_USER_AGENT']);

        // Запись о посещении
        $inDB->query("
            INSERT IGNORE INTO cms_online (ip, sess_id, user_id) VALUES ('$ip', '$sess_id', '$user_id') ON DUPLICATE KEY UPDATE agent = '$useragent', viewurl = ''
        ");

        cmsUser::clearOnlineUsers();

        $res = $inDB->query("
            SELECT user_id FROM cms_online WHERE user_id IN ($ids)
        ");

        if (!$inDB->num_rows($res))
        {
            return array();
        }

        while ($contact = $inDB->fetch_assoc($res))
        {
            $online_ids[] = $contact['user_id'];
        }

        return $online_ids;
    }

/* -------------------------------------------------------------------------- */

    public static function getContactsUpdate($to_id)
    {
        $inDB = cmsDatabase::getInstance();

        $res = $inDB->query("
            SELECT c.contact_id AS id, IFNULL(COUNT(m.id), 0) AS new_messages, IF(o.user_id, 1, 0) AS online
            FROM cms_user_contacts c
            LEFT JOIN cms_user_msg AS m ON m.from_id = c.contact_id AND m.to_id = c.user_id AND m.is_new = 1 AND to_del = 0
            LEFT JOIN cms_online o ON o.user_id = c.contact_id
            WHERE c.user_id = '$to_id' AND c.contact_id > 0
            GROUP BY c.contact_id
            ORDER BY c.date_last_msg DESC
            LIMIT 1000
        ");

        if (!$inDB->num_rows($res))
        {
            return array();
        }
 
        while ($contact = $inDB->fetch_assoc($res))
        {
            $contacts[] = $contact;
        }
 
        return $contacts;
    }

/* -------------------------------------------------------------------------- */

}